/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Simple.xs. Do not edit this file, edit Simple.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Simple.xs"
// PERL_NO_GET_CONTEXT is not used here, so it's OK to define it after inculding these files
#include "EXTERN.h"
#include "perl.h"

// There are a lot of macro about threads: USE_ITHREADS, USE_5005THREADS, I_PTHREAD, I_MACH_CTHREADS, OLD_PTHREADS_API
// This symbol, if defined, indicates that Perl should be built to use the interpreter-based threading implementation.
#ifndef USE_ITHREADS
#   define PERL_NO_GET_CONTEXT
#endif

#include "XSUB.h"

#ifdef I_PTHREAD
#   include "pthread.h"
#endif

#ifdef I_MACH_CTHREADS
#   include "mach/cthreads.h"
#endif

#include <errno.h>
#include <string>
#include <string_view>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/un.h>

#ifdef WIN32
#   include <windows.h>
#   include <winsock2.h>
#else
#   include <netinet/in.h>
#   include <arpa/inet.h>
#   include <sys/types.h>
#endif

#include <time.h>
#include <fcntl.h>

using namespace std;

struct xs_state {
    uint32_t invalid_key_counter;
    HV* bulk_hv;
    HV* avg_hv;
    HV* invalid_hv;
    REGEXP* block_re;
    SV* hostname;
    SV* global_prefix;
    SV* sender_name;
    SV* sock_path;
    uint32_t port;
    int sock_fd;
    bool is_sock_stream;
    bool is_enabled;
    bool is_connected;
    bool use_global_storage;
    bool store_invalid_metrics;
    sockaddr_in sock_addr_inet;
    sockaddr_un sock_addr_unix;
};

typedef struct xs_state GraphiteXS_Object;

static SV* sv_use_sock_stream_key;
static SV* sv_store_invalid_metrics_key;
static SV* sv_use_global_storage_key;
static SV* sv_sender_key;
static SV* sv_block_re_key;
static SV* sv_sock_path_key;
static SV* sv_host_key;
static SV* sv_port_key;
static SV* sv_enabled_key;
static SV* sv_prefix_key;
static uint32_t MAX_CHUNK_SIZE;

inline void increment_hash_value_by ( HV* hv, SV* key, NV value ) {

    HE *ent = hv_fetch_ent( hv, key, 0, 0 );

    if (ent == NULL) // adding the new key
        hv_store_ent( hv, move( key ), move( newSVnv( value ) ), 0 );
    else { // updating the existed key

        SV* he_value = HeVAL(ent);
        NV  nv_value = SvNV( he_value ) + (double) value;

        if (!SvREADONLY( he_value ))
            sv_setnv( he_value, move( nv_value ) );
        else
            hv_store_ent( hv, move(key), move( newSVnv( nv_value ) ), move( HeHASH(ent) ) );
    }
}

inline bool is_metric_blocked_ (GraphiteXS_Object* graphite, SV* key) {
    bool is_blocked = false;
    if ( NULL != graphite->block_re ) {
        char* ckey = SvPVX(key);
        if ( pregexec( graphite->block_re, ckey, SvEND(key), move(ckey), 1, move(key), 1 ) )
            is_blocked = true;
    }
    return is_blocked;
}

static inline bool is_valid_key_ (GraphiteXS_Object* graphite, SV* key) {

    // https://www.linux.org.ru/forum/development/5908806
    // pregcomp pregexec pregfree pregfree2 (man perlapi)

    bool is_valid = true;
    static REGEXP* key_re;

    if ( key_re == NULL ) {
        const char* pattern = "[^a-zA-Z0-9_\\.-]";
        SV* svpat = sv_2mortal(newSVpv(pattern, strlen(pattern)));
        key_re = pregcomp(move(svpat), 0);
    }

    // if (! defined($key) || "${key}" eq '' || !utf8::valid($key) || $key =~ m#[^a-zA-Z0-9\-_\.]#) {
    if ( SVt_NULL == SvTYPE(key) )
        is_valid = false;
    else {
        char* ckey = SvPVX(key);
        if ( 0 == strlen(ckey) || ! SvPOK_only_UTF8(key) || pregexec( key_re, ckey, SvEND(key), move(ckey), 1, move(key), 1 ) )
            is_valid = false;
    }

    if ( ! is_valid )
        graphite->invalid_key_counter++;

    return is_valid;
}

static inline void increment_metric_ (GraphiteXS_Object* graphite, SV* key, NV value) {
    bool is_valid = is_valid_key_(graphite, key);
    if ( is_valid && ! is_metric_blocked_(graphite, key) ) {
        increment_hash_value_by( move(graphite->bulk_hv), key, move(value) );
        static string key_matcher ('\0', 128);
        key_matcher.assign(SvPVX( key ));
        if ( 0 == key_matcher.find( "avg." ) )
            increment_hash_value_by( move(graphite->avg_hv), move(key), 1 );
    } else if (! is_valid && graphite->store_invalid_metrics) {
        increment_hash_value_by( graphite->invalid_hv, move(key), move(value) );
    }
}

inline void clear_bulk_(GraphiteXS_Object* graphite) {
    if (graphite->store_invalid_metrics)
        hv_clear(graphite->invalid_hv);
    hv_clear(graphite->bulk_hv);
    hv_clear(graphite->avg_hv);
    graphite->invalid_key_counter = 0;
}

inline void set_blocked_metrics_re_ (GraphiteXS_Object* graphite, SV* block_re) {
    if (!block_re || SVt_NULL == SvTYPE(block_re)) {
        if (graphite->block_re) // pregfree(graphite->block_re)
            SvREFCNT_dec_NN(graphite->block_re);
        graphite->block_re = NULL;
    }
    else {
        // if (SvREADONLY(block_re)) // can be set via perl call of Internals::SvREADONLY($var => 1);

        if (graphite->block_re) // pregfree
            SvREFCNT_dec_NN(graphite->block_re);

        char* pattern = SvPV_nolen(block_re);
        SV* svpat = sv_2mortal(newSVpv(pattern, strlen(pattern)));
        graphite->block_re = pregcomp(move(svpat), 0);
        // sv_dump((SV *) graphite->block_re);
        // graphite->block_re = SvRX(block_re); // "NULL" will be returned if a REGEXP* is not found.
    }
}

inline void calculate_result_metrics_ (GraphiteXS_Object* graphite, HV* res_hv) {

    HE* bulk_entry = NULL;

    hv_iterinit(graphite->bulk_hv);

    while (bulk_entry = hv_iternext(graphite->bulk_hv)) {

        SV* sv_bulk_key = hv_iterkeysv(bulk_entry);
        SV* sv_bulk_value = hv_iterval(graphite->bulk_hv, move(bulk_entry));
        HE* avg_entry = hv_fetch_ent(graphite->avg_hv, sv_bulk_key, NULL, 0);
        HE* res_entry = hv_fetch_ent(res_hv, move(sv_bulk_key), NULL, 0);
        SV* sv_result_value;

        if (avg_entry) {
            SV* sv_avg_value = hv_iterval(graphite->avg_hv, move(avg_entry));
            sv_result_value = sv_2mortal(newSV(0));
            sv_setnv( sv_result_value, SvNV(sv_bulk_value) / SvNV(sv_avg_value) );
        }
        else
            sv_result_value = sv_mortalcopy(move(sv_bulk_value));

        SvREFCNT_inc_simple_void_NN(sv_result_value);
        // HeHASH(res_entry) wasn't calcualted previuously due to it's an empty hash
        hv_store_ent(res_hv, move(sv_bulk_key), move(sv_result_value), 0);
    }
}

void calculate_result_metrics_ (GraphiteXS_Object* graphite) {

    HE* avg_entry = NULL;

    hv_iterinit(graphite->avg_hv);

    while (avg_entry = hv_iternext(graphite->avg_hv)) {

        SV* sv_avg_key = hv_iterkeysv(avg_entry);
        SV* sv_avg_value = hv_iterval(graphite->bulk_hv, move(avg_entry));
        HE* bulk_entry = hv_fetch_ent(graphite->bulk_hv, sv_avg_key, NULL, 0);

        if (!bulk_entry)
            croak("No bulk entry found for key '%s'", SvPV_nolen(sv_avg_key));

        SV* sv_bulk_value = hv_iterval(graphite->bulk_hv, move(bulk_entry));
        sv_setnv( sv_bulk_value, SvNV(sv_bulk_value) / SvNV(sv_avg_value) );

        SvREFCNT_inc_simple_void_NN(sv_bulk_value);
        hv_store_ent(graphite->bulk_hv, move(sv_avg_key), move(sv_bulk_value), move(HeHASH(bulk_entry)));
    }
}

inline void apply_store_invalid_metrics_key_ (GraphiteXS_Object* graphite, HV* opts) {
    HE* entry = hv_fetch_ent(opts, sv_store_invalid_metrics_key, NULL, 0);
    if (entry)
        graphite->store_invalid_metrics = SvIVx(hv_iterval(opts, entry)) ? true : false;
}

inline void apply_sender_key_ (GraphiteXS_Object* graphite, HV* opts) {
    HE* entry = entry = hv_fetch_ent(opts, sv_sender_key, NULL, 0);
    if (entry) {
        graphite->sender_name = move(HeVAL(entry));

        if ( !graphite->sender_name )
            croak("Sender sub name can't be undefined. Specify its name with package. Example: My::Package::my_sub");

        // Let's check that the sub exists
        if (!(CV *) get_cv(SvPVX(graphite->sender_name), 0))
            croak("Can't find sender sub: %s", SvPVX(graphite->sender_name));

        SvREFCNT_inc_simple_void_NN(graphite->sender_name);
    }
}

inline void apply_use_global_storage_key_ (GraphiteXS_Object* graphite, HV* opts) {
    HE* entry = hv_fetch_ent(opts, sv_use_global_storage_key, NULL, 0);
    if (entry)
        graphite->use_global_storage = SvIVx(hv_iterval(opts, entry)) ? true : false;

    if (graphite->use_global_storage) {
        graphite->bulk_hv    = get_hv("Graphite::Simple::bulk", GV_ADD);
        graphite->avg_hv     = get_hv("Graphite::Simple::avg_counters", GV_ADD);
        graphite->invalid_hv = get_hv("Graphite::Simple::invalid", GV_ADD);
    } else {
        graphite->bulk_hv    = newHV();
        graphite->avg_hv     = newHV();
        graphite->invalid_hv = newHV();
    }
}

inline void apply_block_re_key_ (GraphiteXS_Object* graphite, HV* opts) {
    HE* entry = hv_fetch_ent(opts, sv_block_re_key, NULL, 0);
    if (entry)
        set_blocked_metrics_re_(graphite, hv_iterval(opts, entry));
}

inline void apply_enabled_key_ (GraphiteXS_Object* graphite, HV* opts) {
    HE* entry = hv_fetch_ent(opts, sv_enabled_key, NULL, 0);
    if (entry != NULL)
        graphite->is_enabled = SvNVx(hv_iterval(opts, entry)) ? true : false; // by default: "enabled" => false
}

inline void apply_prefix_key_ (GraphiteXS_Object* graphite, HV* opts) {
    STRLEN prefix_len = 0;
    HE* entry = hv_fetch_ent(opts, sv_prefix_key, NULL, 0);

    if (entry != NULL) {
        graphite->global_prefix = move(HeVAL(entry));
        const char *prefix = SvPVX(graphite->global_prefix);

        if ((prefix_len = SvCUR(graphite->global_prefix)) > 0) {
            if (prefix[prefix_len - 1] != '.')
                sv_catpvn(graphite->global_prefix, ".", 1);
            SvREFCNT_inc_simple_void_NN(graphite->global_prefix);
        }
    }

    if (!prefix_len)
        croak("You have to setup project name (global prefix)");
}

inline void apply_sock_path_key_ (GraphiteXS_Object* graphite, HV* opts) {
    HE* entry = hv_fetch_ent(opts, sv_sock_path_key, NULL, 0);
    if (entry != NULL) {

        graphite->sock_path = move(HeVAL(entry));

        if (!sv_len(graphite->sock_path))
            croak("'path' can't be an empty string");

        graphite->sock_addr_unix.sun_family = AF_LOCAL;
        strcpy(graphite->sock_addr_unix.sun_path, SvPVX(graphite->sock_path));
    }
}

inline void apply_host_and_port_keys_ (GraphiteXS_Object* graphite, HV* opts) {

    // Initially we treat hostname as host, and only in case of failure we treat it as IP
    in_addr_t addr = 0;
    HE* entry = hv_fetch_ent(opts, sv_host_key, NULL, 0);

    if (graphite->sock_path && entry != NULL)
        croak("At once can be specified either 'path' or 'host' and 'port'.");

    if (entry != NULL) {

        struct hostent *host;

        graphite->hostname = move(HeVAL(entry));

        SvREFCNT_inc_simple_void_NN(graphite->hostname);

        char* hostname = SvPVX(graphite->hostname);

        if ((host = gethostbyname(hostname)) != NULL)
            addr = *(long *)(host->h_addr_list[0]);
        else if ( (addr = inet_addr(hostname)) < 0)
            croak("Invalid hostname '%s' was given", hostname);
    }

    if (graphite->sock_path) // do nothing
        return(void());

    if (addr <= 0)
        croak("Neither host nor ip was given");

    if ((entry = hv_fetch_ent(opts, sv_port_key, NULL, 0)) != NULL)
        graphite->port = (uint32_t) SvIVx(hv_iterval(opts, entry));

    if (!graphite->port)
        croak("No port number was given");

    graphite->sock_addr_inet.sin_addr.s_addr = addr; //*(long *)(host->h_addr_list[0]);
    graphite->sock_addr_inet.sin_port = htons(graphite->port);
    graphite->sock_addr_inet.sin_family = AF_INET;
}

inline void apply_use_sock_stream_key_ (GraphiteXS_Object* graphite, HV* opts) {
    HE* entry = hv_fetch_ent(opts, sv_use_sock_stream_key, NULL, 0);
    if (entry)
        graphite->is_sock_stream = SvIVx(hv_iterval(opts, entry)) ? true : false;
}

inline void apply_constructor_options_ (GraphiteXS_Object* graphite, HV* opts) {

    apply_store_invalid_metrics_key_(graphite, opts);
    apply_sender_key_(graphite, opts);
    apply_use_global_storage_key_(graphite, opts);
    apply_block_re_key_(graphite, opts);
    apply_enabled_key_(graphite, opts);

    if (graphite->is_enabled) {
        apply_prefix_key_(graphite, opts);
        apply_sock_path_key_(graphite, opts);
        apply_host_and_port_keys_(graphite, opts);
        apply_use_sock_stream_key_(graphite, opts);
    }
}

inline void connect_ (GraphiteXS_Object* graphite) {
    if (graphite->is_connected)
        return(void());

    if (graphite->sock_path) {
        // AF_UNIX -> AF_LOCAL
        if ((graphite->sock_fd = socket(AF_LOCAL, graphite->is_sock_stream ? SOCK_STREAM : SOCK_DGRAM, 0)) == -1)
            croak("Error: can't create socket: %s\n", strerror(errno));

        if (fcntl(graphite->sock_fd, F_SETFL, O_CLOEXEC) == -1)
            croak("Error: can't set socket flags: %s\n", strerror(errno));

        if(connect(graphite->sock_fd, (struct sockaddr *) &graphite->sock_addr_unix, sizeof(graphite->sock_addr_unix)) < 0)
            croak("Error: connection is failed to %s: %s\n", SvPVX(graphite->sock_path), strerror(errno));
    }
    else if (graphite->hostname && graphite->port) {
        if((graphite->sock_fd = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
            croak("Error: can't create socket: %s\n", strerror(errno));

        if (fcntl(graphite->sock_fd, F_SETFL, O_NONBLOCK | O_ASYNC | O_CLOEXEC) == -1)
            croak("Error: can't set socket flags: %s\n", strerror(errno));

        if(connect(graphite->sock_fd, (struct sockaddr *) &graphite->sock_addr_inet, sizeof(graphite->sock_addr_inet)) < 0)
            croak("Error: connection is failed to %s:%i: %s\n", SvPVX(graphite->hostname), graphite->port,  strerror(errno));
    }

    if (graphite->sock_fd)
        graphite->is_connected = true;
}

inline void disconnect_ (GraphiteXS_Object* graphite) {
    if (graphite->is_connected) {
        close(graphite->sock_fd);
        graphite->is_connected = false;
        graphite->sock_fd = 0;
    }
}


#line 422 "Simple.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 566 "Simple.c"

XS_EUPXS(XS_Graphite__Simple_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class_name, opts");
    {
	GraphiteXS_Object *	RETVAL;
	char *	class_name = (char *)SvPV_nolen(ST(0))
;
	HV *	opts;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    opts = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Graphite::Simple::new",
				"opts");
		}
	} STMT_END
;
#line 434 "Simple.xs"
    GraphiteXS_Object *self = (GraphiteXS_Object *) safemalloc(sizeof(GraphiteXS_Object));

    self->invalid_key_counter = 0;
    self->bulk_hv = nullptr;
    self->avg_hv  = nullptr;
    self->invalid_hv = nullptr;
    self->block_re = NULL;
    self->is_enabled = false;
    self->is_connected = false;
    self->is_sock_stream = false;
    self->use_global_storage = false;
    self->store_invalid_metrics = false;
    self->global_prefix = nullptr;
    self->sock_path = nullptr;
    self->sender_name = nullptr;
    self->hostname = nullptr;
    self->port = 0;
    self->sock_fd = 0;

    memset(&self->sock_addr_unix, 0, sizeof(sockaddr_un));
    memset(&self->sock_addr_inet, 0, sizeof(sockaddr_in));
    apply_constructor_options_(self, opts);

    RETVAL = self;
#line 618 "Simple.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, class_name, (void*) RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Graphite__Simple_is_connected); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_is_connected)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	IV	RETVAL;
	dXSTARG;
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 464 "Simple.xs"
    mXPUSHi(self->is_connected ? 1 : 0);
    XSRETURN(1);
#line 656 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_connect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	IV	RETVAL;
	dXSTARG;
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 470 "Simple.xs"
    connect_(self);
    mXPUSHi(self->is_connected ? 1 : 0);
    XSRETURN(1);
#line 690 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_reconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_reconnect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	IV	RETVAL;
	dXSTARG;
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 477 "Simple.xs"
    disconnect_(self);
    connect_(self);
    mXPUSHi(self->is_connected ? 1 : 0);
    XSRETURN(1);
#line 725 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_disconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_disconnect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 485 "Simple.xs"
    disconnect_(self);
    XSRETURN_EMPTY;
#line 756 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_get_bulk_metrics); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_get_bulk_metrics)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HV *	RETVAL;
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 491 "Simple.xs"
    //ST(0) = sv_mortalcopy((SV *) self->bulk_hv); // mXPUSHs((SV *) self->bulk_hv );
    //ST(0) = sv_2mortal(newRV_noinc( (SV *) self->bulk_hv ));
    //XSRETURN(1);
    RETVAL = self->bulk_hv;
#line 788 "Simple.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Graphite__Simple_get_invalid_metrics); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_get_invalid_metrics)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HV *	RETVAL;
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 501 "Simple.xs"
    RETVAL = self->invalid_hv;
#line 822 "Simple.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Graphite__Simple_send_bulk); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_send_bulk)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	RETVAL;
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 509 "Simple.xs"
    IV is_success = 1;

    if (self->is_connected) {

        SSize_t keys_cnt = hv_iterinit(self->bulk_hv);

        if (keys_cnt) {

            // writes results into self->bulk_hv
            calculate_result_metrics_(self);

            STRLEN len, key_len = 0;
            const char *prefix = SvPVX(self->global_prefix);
            HE *entry = NULL;

            static string_view suffix;
            static string data ("");
            static bool is_first_time = true;
            static int send_flags = MSG_NOSIGNAL; // we don't set MSG_DONTWAIT flag because O_NONBLOCK is already set via fcntl

            if (is_first_time) {
                data.reserve(MAX_CHUNK_SIZE + 100);
                is_first_time = false;
            }

            suffix = move( string_view(move( " " + to_string(time(NULL)).append("\n") )) );

            while (entry = hv_iternext(self->bulk_hv)) {

                data.append(prefix);
                data.append(move(HePV(entry, key_len)));
                data.append(" ");
                data.append(move(SvPV_nolen(HeVAL(entry))));
                data.append(suffix);

                if (( len = data.length() ) >= MAX_CHUNK_SIZE) {
                    //warn("data:\n%s", data.c_str());
                    if (send(self->sock_fd, data.c_str(), move(len), send_flags) == -1) {
                        if (self->sock_path) {
                            disconnect_(self);
                            data.clear();
                            croak("Error: can't send. %s\n", strerror(errno));
                        }
                        is_success = 0;
                    }
                    data.clear();
                }
            }

            if ((len = data.length()) > 0) { // if we have only one key, then "len" iz zero here
                //warn("data:\n%s", data.c_str());
                if (send(self->sock_fd, data.c_str(), move(len), send_flags) == -1) {
                    if (self->sock_path) {
                        disconnect_(self);
                        data.clear();
                        croak("Error: can't send. %s\n", strerror(errno));
                    }
                    is_success = 0;
                }
                data.clear();
            }
        }
    }
    else
        warn("Client is not connected to server");

    clear_bulk_(self);
    mXPUSHi(move(is_success));
    XSRETURN(1);
#line 926 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_send_bulk_delegate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_send_bulk_delegate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	RETVAL;
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 583 "Simple.xs"
    const char *sender = SvPVX(self->sender_name);

    if (!sender)
        croak("No sender was specified");

    calculate_result_metrics_(self);

    // see "man perlcall" for details

    IV status = 0;

    dSP; // Declares a local copy of perl's stack pointer for the XSUB, available via the "SP" macro.  See "SP".
    I32 ax;
    I32 count;

    ENTER;         // Opening bracket on a callback.  See "LEAVE" and perlcall.
    SAVETMPS;      // pening bracket for temporaries on a callback.  See "FREETMPS" and perlcall.
    PUSHMARK(SP);  // Opening bracket for arguments on a callback.  See "PUTBACK" and perlcall.
    EXTEND(SP, 1); // We are going to pass only one argument
    PUSHs(sv_2mortal(newRV( (SV *) self->bulk_hv ))); // Push into outgoing stack an argument
    PUTBACK;       // Closing bracket for XSUB arguments.  This is usually handled by "xsubpp".  See "PUSHMARK" and perlcall for other uses.

    count = call_pv(sender, G_SCALAR);

    SPAGAIN;      // Refetch the stack pointer.  Used after a callback.  See perlcall.
    SP -= count;
    ax = (SP - PL_stack_base) + 1;

    if (count != 1)
        croak("Unexpected size of returned stack from sender\n");

    uint32_t type = SvTYPE(ST(0));

    if (SVt_IV == type || SVt_NV == type)
        status = SvIV(ST(0)); // round the value
    else
        warn("The sender must return a number type of status. Using 0 as sender status now.");

    PUTBACK;  // Closing bracket for XSUB arguments.  This is usually handled by "xsubpp".  See "PUSHMARK" and perlcall for other uses.
    FREETMPS; // Closing bracket for temporaries on a callback.  See "SAVETMPS" and perlcall.
    LEAVE;    // Closing bracket on a callback.  See "ENTER" and perlcall.

    // warn("status: %d\n", status);
    clear_bulk_(self);
    mXPUSHi(status);
    XSRETURN(1);
#line 1002 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_get_metrics); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_get_metrics)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HV *	RETVAL;
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 633 "Simple.xs"
    HV* res_hv = (HV *) sv_2mortal((SV*) newHV());
    calculate_result_metrics_(self, res_hv);
    RETVAL = move(res_hv);
#line 1033 "Simple.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Graphite__Simple_get_average_counters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_get_average_counters)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HV *	RETVAL;
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 642 "Simple.xs"
    RETVAL = self->avg_hv;
#line 1067 "Simple.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Graphite__Simple_clear_bulk); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_clear_bulk)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 649 "Simple.xs"
    clear_bulk_(self);
    XSRETURN_EMPTY;
#line 1103 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_incr_bulk); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_incr_bulk)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, key, value= 1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	GraphiteXS_Object *	self;
	SV *	key = ST(1)
;
	NV	value;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;

	if (items < 3)
	    value = 1;
	else {
	    value = (NV)SvNV(ST(2))
;
	}
#line 655 "Simple.xs"
    bool is_ok = false;
    if (key != &PL_sv_undef) {
        uint32_t key_type = SvTYPE(key);
        if (key_type == SVt_PVLV || key_type == SVt_PVMG) {
            // SVt_PVLV can be returned from substr
            // SVt_PVMG can be returned from RegExp
            STRLEN key_len;
            char *ch = SvPVx(move(key), key_len);
            key = newSVpv(move(ch), move(key_len));
        }
        if (SvTYPE(key) == SVt_PV) {
            is_ok = true;
            increment_metric_( self, move(key), move(value) );
        }
    }

    if (!is_ok)
        croak("key must be a string");

    XSRETURN_EMPTY;
#line 1162 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_append_bulk); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_append_bulk)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, hv, prefix= &PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	GraphiteXS_Object *	self;
	HV *	hv;
	SV *	prefix;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    hv = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Graphite::Simple::append_bulk",
				"hv");
		}
	} STMT_END
;

	if (items < 3)
	    prefix = &PL_sv_undef;
	else {
	    prefix = ST(2)
;
	}
#line 680 "Simple.xs"
    if (SvTIED_mg((SV *) hv, PERL_MAGIC_tied))
        croak("Tied hashes are not supported");

    bool use_prefix = false;

    if (prefix && prefix != &PL_sv_undef) {

        uint32_t type = SvTYPE(prefix);

        use_prefix = type == SVt_PV || type == SVt_PVLV;

        if (!use_prefix && type != SVt_NULL)
            croak("prefix must be a string or undefined");
    }

    HE* entry = NULL;
    static string sprefix ('\0', 128); // preallocate 128 byte

    if (use_prefix) {
        sprefix.assign( SvPVX(prefix) );
        if (sprefix.back() != '.')
            sprefix.append(".");
    }

    hv_iterinit(hv);

    while (entry = hv_iternext(hv)) {

        SV* key = hv_iterkeysv(entry);
        SV* value = hv_iterval(hv, move(entry));
        uint32_t value_type = SvTYPE(value);

        if (
                SvROK(value) ||
                (
                    // value_type < SVt_IV || value_type > SVt_PVNV
                    SVt_IV != value_type &&
                    SVt_NV != value_type &&
                    SVt_PV != value_type &&
                    SVt_PVNV != value_type &&
                    SVt_PVIV != value_type
                )
           ) {
            warn("Value type of key '%s' is not a number", SvPVX(key));
            continue;
        }

        if (use_prefix)
            sv_setpv(key, ( sprefix + SvPVX(key) ).c_str());

        increment_metric_( self, move(key), move(SvNVx(value)) );
    }

    XSRETURN_EMPTY;
#line 1268 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_is_valid_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_is_valid_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	RETVAL;
	GraphiteXS_Object *	self;
	SV *	key = ST(1)
;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 738 "Simple.xs"
    bool is_valid = is_valid_key_(self, move(key));
    mXPUSHi( move(is_valid ? 1 : 0) );
    XSRETURN(1);
#line 1303 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_get_invalid_key_counter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_get_invalid_key_counter)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	IV	RETVAL;
	dXSTARG;
	GraphiteXS_Object *	self;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 745 "Simple.xs"
    mXPUSHi( self->invalid_key_counter );
    XSRETURN(1);
#line 1336 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_check_and_bump_invalid_metric); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_check_and_bump_invalid_metric)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	GraphiteXS_Object *	self;
	SV *	key = ST(1)
;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 751 "Simple.xs"
    if ( SVt_NULL != SvTYPE(key) ) {
        uint32_t counter = move(self->invalid_key_counter);
        self->invalid_key_counter = 0;
        increment_hash_value_by( self->bulk_hv, move(key), move(counter) );
    }
    XSRETURN_EMPTY;
#line 1373 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_is_metric_blocked); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_is_metric_blocked)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	IV	RETVAL;
	dXSTARG;
	GraphiteXS_Object *	self;
	SV *	key = ST(1)
;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;
#line 761 "Simple.xs"
    bool is_blocked = false;
    if ( is_valid_key_(self, key) )
        is_blocked = is_metric_blocked_(self, move(key));
    mXPUSHi( move(is_blocked ? 1 : 0) );
    XSRETURN(1);
#line 1411 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_set_blocked_metrics_re); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_set_blocked_metrics_re)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, block_re= &PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	GraphiteXS_Object *	self;
	SV *	block_re;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        //if (1 || sv_derived_from(ST(0), "Graphite::SImple"))
        //  {
            self = INT2PTR(GraphiteXS_Object *, SvUV((SV *) SvRV(ST(0))));
        //  }
        //else
        //  croak("self is not of type Graphite::Simple")
;

	if (items < 2)
	    block_re = &PL_sv_undef;
	else {
	    block_re = ST(1)
;
	}
#line 770 "Simple.xs"
    set_blocked_metrics_re_(self, block_re);
    XSRETURN_EMPTY;
#line 1450 "Simple.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graphite__Simple_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graphite__Simple_DESTROY)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 776 "Simple.xs"
    GraphiteXS_Object *self = (GraphiteXS_Object *) SvUV(SvRV(ST(0)));
    if (PL_dirty) // global destruction
        return;
    if (self->sender_name && SvREFCNT(self->sender_name)) // sv_clear
        SvREFCNT_dec_NN(self->sender_name);
    if (self->global_prefix && SvREFCNT(self->global_prefix)) // sv_clear
        SvREFCNT_dec_NN(self->global_prefix);
    if (self->hostname && SvREFCNT(self->hostname)) // sv_clear
        SvREFCNT_dec_NN(self->hostname);
    if (self->sock_path && SvREFCNT(self->sock_path)) // sv_clear
        SvREFCNT_dec_NN(self->sock_path);
    if (self->block_re && SvREFCNT(self->block_re))
        SvREFCNT_dec_NN(self->block_re);
    if (!self->use_global_storage) {
        if (self->bulk_hv) // hv_undef
            SvREFCNT_dec_NN(self->bulk_hv);
        if (self->avg_hv) // hv_undef
            SvREFCNT_dec_NN(self->avg_hv);
        if (self->invalid_hv) // hv_undef
            SvREFCNT_dec_NN(self->invalid_hv);
    }
    disconnect_(self);
    //dump_all();
    safefree(move(self));
    XSRETURN_EMPTY;
#line 1492 "Simple.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Graphite__Simple); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Graphite__Simple)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Graphite::Simple::new", XS_Graphite__Simple_new);
        newXS_deffile("Graphite::Simple::is_connected", XS_Graphite__Simple_is_connected);
        newXS_deffile("Graphite::Simple::connect", XS_Graphite__Simple_connect);
        newXS_deffile("Graphite::Simple::reconnect", XS_Graphite__Simple_reconnect);
        newXS_deffile("Graphite::Simple::disconnect", XS_Graphite__Simple_disconnect);
        newXS_deffile("Graphite::Simple::get_bulk_metrics", XS_Graphite__Simple_get_bulk_metrics);
        newXS_deffile("Graphite::Simple::get_invalid_metrics", XS_Graphite__Simple_get_invalid_metrics);
        newXS_deffile("Graphite::Simple::send_bulk", XS_Graphite__Simple_send_bulk);
        newXS_deffile("Graphite::Simple::send_bulk_delegate", XS_Graphite__Simple_send_bulk_delegate);
        newXS_deffile("Graphite::Simple::get_metrics", XS_Graphite__Simple_get_metrics);
        newXS_deffile("Graphite::Simple::get_average_counters", XS_Graphite__Simple_get_average_counters);
        newXS_deffile("Graphite::Simple::clear_bulk", XS_Graphite__Simple_clear_bulk);
        newXS_deffile("Graphite::Simple::incr_bulk", XS_Graphite__Simple_incr_bulk);
        newXS_deffile("Graphite::Simple::append_bulk", XS_Graphite__Simple_append_bulk);
        newXS_deffile("Graphite::Simple::is_valid_key", XS_Graphite__Simple_is_valid_key);
        newXS_deffile("Graphite::Simple::get_invalid_key_counter", XS_Graphite__Simple_get_invalid_key_counter);
        newXS_deffile("Graphite::Simple::check_and_bump_invalid_metric", XS_Graphite__Simple_check_and_bump_invalid_metric);
        newXS_deffile("Graphite::Simple::is_metric_blocked", XS_Graphite__Simple_is_metric_blocked);
        newXS_deffile("Graphite::Simple::set_blocked_metrics_re", XS_Graphite__Simple_set_blocked_metrics_re);
        newXS_deffile("Graphite::Simple::DESTROY", XS_Graphite__Simple_DESTROY);

    /* Initialisation Section */

#line 417 "Simple.xs"
{
    sv_use_sock_stream_key = move(newSVpv("use_sock_stream", strlen("use_sock_stream")));
    sv_store_invalid_metrics_key = move(newSVpv("store_invalid_metrics", strlen("store_invalid_metrics")));
    sv_use_global_storage_key = move(newSVpv("use_common_storage", strlen("use_global_storage")));
    sv_sender_key   = move(newSVpv("sender_name", strlen("sender_name")));
    sv_block_re_key = move(newSVpv("block_metrics_re", strlen("block_metrics_re")));
    sv_sock_path_key = move(newSVpv("path", strlen("path")));
    sv_host_key = move(newSVpv("host", strlen("host")));
    sv_port_key = move(newSVpv("port", strlen("port")));
    sv_enabled_key = move(newSVpv("enabled", strlen("enabled")));
    sv_prefix_key = move(newSVpv("project", strlen("project")));
    MAX_CHUNK_SIZE = 1460;
}

#line 1564 "Simple.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
